#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2900one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one29004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2900
# -------------------------------------------------------------------------------------------------                                          
shot2one29004xi = {
                  1:'0x0y2899z',
                  2:'0x1920y2173z',
                  3:'0x87y2898z',
                  4:'1013x2286y1467z',
                  5:'1017x2417y1237z',
                  6:'1020x1260y2403z',
                  7:'1066x2009y1798z',
                  8:'1069x1187y2420z',
                  9:'1069x1712y2081z',
                  10:'109x94y2896z',
                  11:'1112x1112y2435z',
                  12:'1125x2217y1492z',
                  13:'1136x2349y1263z',
                  14:'1146x1636y2101z',
                  15:'1151x1036y2451z',
                  16:'1161x1935y1821z',
                  17:'1184x959y2466z',
                  18:'1213x881y2481z',
                  19:'1217x1557y2121z',
                  20:'1232x2142y1517z',
                  21:'1250x1856y1843z',
                  22:'1251x2275y1289z',
                  23:'125x120y2894z',
                  24:'1283x1476y2141z',
                  25:'131x2594y1289z',
                  26:'1334x2061y1542z',
                  27:'1335x1773y1865z',
                  28:'1343x1391y2160z',
                  29:'1362x2196y1315z',
                  30:'138x148y2892z',
                  31:'1398x1304y2179z',
                  32:'13x346y2879z',
                  33:'1414x1686y1888z',
                  34:'1431x1976y1566z',
                  35:'1448x1215y2198z',
                  36:'1467x2110y1341z',
                  37:'1487x1596y1909z',
                  38:'1492x1124y2217z',
                  39:'149x177y2890z',
                  40:'1522x1886y1590z',
                  41:'1530x1032y2236z',
                  42:'1555x1503y1931z',
                  43:'1568x2020y1366z',
                  44:'157x207y2888z',
                  45:'1608x1792y1615z',
                  46:'1617x1407y1953z',
                  47:'162x239y2885z',
                  48:'163x306y2879z',
                  49:'164x272y2882z',
                  50:'164x352y2974z',
                  51:'1662x1925y1392z',
                  52:'166x2405y1610z',
                  53:'1673x1308y1974z',
                  54:'1688x1694y1639z',
                  55:'16x23y2899z',
                  56:'1722x1207y1995z',
                  57:'1751x1825y1417z',
                  58:'1763x1592y1662z',
                  59:'1830x1487y1686z',
                  60:'1834x1721y1442z',
                  61:'1892x1379y1710z',
                  62:'1910x1613y1468z',
                  63:'191x2189y1891z',
                  64:'196x1865y2211z',
                  65:'1980x1502y1492z',
                  66:'225x2682y1077z',
                  67:'266x2570y1315z',
                  68:'28x317y2882z',
                  69:'290x1831y2229z',
                  70:'290x2377y1634z',
                  71:'303x2157y1913z',
                  72:'30x49y2899z',
                  73:'364x2656y1104z',
                  74:'380x1791y2248z',
                  75:'398x2540y1340z',
                  76:'3x29y2899z',
                  77:'3x58y2899z',
                  78:'411x2342y1658z',
                  79:'412x2120y1935z',
                  80:'41x2427y1586z',
                  81:'41x286y2885z',
                  82:'42x75y2898z',
                  83:'468x1747y2266z',
                  84:'501x2622y1131z',
                  85:'50x255y2888z',
                  86:'517x2076y1956z',
                  87:'51x104y2897z',
                  88:'527x2502y1366z',
                  89:'530x2301y1682z',
                  90:'551x1698y2284z',
                  91:'56x224y2890z',
                  92:'57x133y2896z',
                  93:'59x193y2892z',
                  94:'60x163y2894z',
                  95:'620x2028y1978z',
                  96:'631x1646y2302z',
                  97:'634x2581y1158z',
                  98:'645x2254y1706z',
                  99:'654x2458y1392z',
                  100:'707x1589y2319z',
                  101:'718x1974y1999z',
                  102:'756x2201y1729z',
                  103:'765x2533y1184z',
                  104:'777x2407y1417z',
                  105:'779x1529y2337z',
                  106:'77x2215y1869z',
                  107:'812x1915y2020z',
                  108:'846x1466y2354z',
                  109:'85x2701y1050z',
                  110:'864x2142y1752z',
                  111:'893x2479y1211z',
                  112:'897x2350y1442z',
                  113:'903x1851y2040z',
                  114:'909x1400y2370z',
                  115:'91x71y2897z',
                  116:'967x1331y2387z',
                  117:'967x2078y1775z',
                  118:'988x1784y2061z',
                  119:'99x1895y2192z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2900one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900ONE4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2900ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE29004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one29004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900ONE4XI - SUCCEEDED TO PUT SHOT2ONE29004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE29004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900ONE4XI *** FAILED TO PUT SHOT2ONE29004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one29004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one29004xi</nack2put4xi>" 
              
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
       
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one29004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2900ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
